/// <reference path="../../../../../Widgets/Wijmo/Base/jquery.wijmo.widget.ts"/>
/// <reference path="../../../../../Widgets/Wijmo/wijevcal/jquery.wijmo.wijevcal.ts"/>
var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};

var c1;
(function (c1) {
    var $ = jQuery, hiddenCss = "ui-helper-hidden-accessible", customColorStyleIdPrefix = "c1-c1evcal-color-", customColorTable = {}, customColorTableIndex = 0;

    var c1eventscalendar = (function (_super) {
        __extends(c1eventscalendar, _super);
        function c1eventscalendar() {
            _super.apply(this, arguments);
        }
        c1eventscalendar.prototype._setOption = function (key, value) {
            $.wijmo.wijevcal.prototype._setOption.apply(this, arguments);
        };

        c1eventscalendar.prototype._create = function () {
            var self = this, o = self.options, eventDialogTemplate, eventTemplate, edtSelector = "#" + self.element[0].id + "_EventDialogTemplateContainer";
            self.element.addClass("c1-c1eventscalendar");
            eventDialogTemplate = $(edtSelector);
            eventTemplate = $("#" + self.element[0].id + "_EventTemplateContainer");
            if (eventDialogTemplate.length > 0 && eventDialogTemplate.html()) {
                o.editEventDialogTemplate = edtSelector;
            }
            if (eventTemplate.length > 0) {
                o.eventTemplate = eventTemplate.html();
            }
            eventTemplate.remove();
            $.wijmo.wijevcal.prototype._create.apply(self, arguments);
        };

        c1eventscalendar.prototype._init = function () {
            // remove ui-helper-hidden-accessible before invalidate:
            this.element.removeClass("ui-helper-hidden-accessible");
            $.wijmo.wijevcal.prototype._init.apply(this, arguments);
        };

        // begin override base method
        c1eventscalendar.prototype._onCalendarsChanged = function () {
            var self = this;
            self._normalizeItemColorName(self.options.calendars);
            _super.prototype._onCalendarsChanged.call(this);
        };

        c1eventscalendar.prototype._onEventsDataChanged = function () {
            var self = this;
            self._normalizeItemColorName(self.options.eventsData);
            _super.prototype._onEventsDataChanged.call(this);
        };

        c1eventscalendar.prototype.addEvent = function (o, successCallback, errorCallback) {
            return _super.prototype.addEvent.call(this, this._restoreColorValue(o), successCallback, errorCallback);
        };

        c1eventscalendar.prototype.addCalendar = function (o, successCallback, errorCallback) {
            return _super.prototype.addCalendar.call(this, this._restoreColorValue(o), successCallback, errorCallback);
        };

        c1eventscalendar.prototype.updateEvent = function (o, successCallback, errorCallback) {
            return _super.prototype.updateEvent.call(this, this._restoreColorValue(o), successCallback, errorCallback);
        };

        c1eventscalendar.prototype.updateCalendar = function (o, successCallback, errorCallback) {
            return _super.prototype.updateCalendar.call(this, this._restoreColorValue(o), successCallback, errorCallback);
        };

        // end override base method
        c1eventscalendar.prototype._normalizeItemColorName = function (data) {
            var self = this, colorName;
            $.each(data, function (i, v) {
                if (self._isCustomizedColor(v.color)) {
                    // If the color is already customized(e.g. "black"- > "color1" where "color1" is the customized color name) and the input is the customized color name("color1"), then returns directly.
                    if (customColorTable[v.color]) {
                        return;
                    }

                    // If the color is already customized(e.g. "black"->"color1" where "color1" is the customized color name) and the input is the real color value("black") , then retrieves the color name from customColorTable member.
                    colorName = self._getColorNameByColorValue(v.color);
                    if (colorName) {
                        v.color = colorName;
                        return;
                    }

                    colorName = "color" + customColorTableIndex++;
                    customColorTable[colorName] = v.color;
                    self._generateCustomStylesheet(colorName, v.color);
                    v.color = colorName;
                }
            });
        };

        c1eventscalendar.prototype._restoreColorValue = function (o) {
            var self = this;
            if (self._isCustomizedColor(o.color) && customColorTable[o.color]) {
                o.color = customColorTable[o.color];
            }
            return o;
        };

        c1eventscalendar.prototype._isCustomizedColor = function (color) {
            var self = this, o = self.options;
            return !o.colors || (color && color !== "default" && $.inArray(color, o.colors) === -1);
        };

        c1eventscalendar.prototype._getColorNameByColorValue = function (colorValue) {
            var colorName;
            $.each(customColorTable, function (key, val) {
                if (val === colorValue) {
                    colorName = key;
                }
            });
            return colorName;
        };

        c1eventscalendar.prototype._generateCustomStylesheet = function (colorName, colorValue) {
            var self = this, id = customColorStyleIdPrefix + colorName, eventColorSelector = ".wijmo-wijev-event-color-" + colorName, eventTitleColorSelector = ".wijmo-wijev-title";
            if ($("#" + id).length === 0) {
                $("<style id=\"" + id + "\">" + eventColorSelector + ",\r\n" + eventColorSelector + " " + eventTitleColorSelector + "\r\n {background-color: " + colorValue + "}</style>").appendTo($("head"));
            }
        };

        // public methods>
        c1eventscalendar.prototype.adjustOptions = function () {
            delete this.options.editEventDialogTemplate;
            delete this.options.eventTemplate;
        };

        ///	<summary>
        ///	Destroy the widget and reset the DOM element.
        ///	</summary>
        c1eventscalendar.prototype.destroy = function () {
            this.element.removeClass("c1-c1eventscalendar");
            $.wijmo.wijevcal.prototype.destroy.apply(this, arguments);
        };
        return c1eventscalendar;
    })(wijmo.evcal.wijevcal);
    c1.c1eventscalendar = c1eventscalendar;

    c1eventscalendar.prototype.widgetEventPrefix = "c1eventscalendar";

    c1eventscalendar.prototype.options = $.extend(true, {}, $.wijmo.wijevcal.prototype.options, {});

    $.wijmo.registerWidget("c1eventscalendar", $.wijmo.wijevcal, c1eventscalendar.prototype);
})(c1 || (c1 = {}));
