﻿/// <reference path="../../../../../Widgets/Wijmo/wijpager/jquery.wijmo.wijpager.ts"/>
/// <reference path="../../../../../Widgets/Wijmo/wijgrid/Grid.ts/Grid/wijgrid.ts"/>
/// <reference path="../../../../../Widgets/Wijmo/export/gridexport.ts"/>
var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};

var c1;
(function (c1) {
    var $ = jQuery;

    var c1gridview = (function (_super) {
        __extends(c1gridview, _super);
        function c1gridview() {
            _super.apply(this, arguments);
            this.mParent = null;
            this._detailGrids = null;
        }
        c1gridview.prototype._onRendered = function () {
            this._resetDetailGrids();
            _super.prototype._onRendered.apply(this, arguments);
        };

        c1gridview.prototype.pageCount = function () {
            return this.options.pageCount;
        };

        c1gridview.prototype._serverShaping = function () {
            return true;
        };

        c1gridview.prototype.ensureControl = function (loadData, userData) {
            _super.prototype.ensureControl.apply(this, arguments);
        };

        c1gridview.prototype._canInteract = function () {
            return _super.prototype._canInteract.apply(this, arguments) && !this.mCallbackInProgress;
        };

        c1gridview.prototype._freezingAllowed = function () {
            return !this.options.innerState._hd && _super.prototype._freezingAllowed.apply(this, arguments);
        };

        c1gridview.prototype._init = function () {
            // ** map server properties to wijgrid
            if (this.options.allowClientEditing) {
                this.options.editingMode = "cell";
            }

            if (this.options.clientSelectionMode) {
                this.options.selectionMode = this.options.clientSelectionMode;
            }

            this.options.showSelectionOnRender = this.options.showClientSelectionOnRender;

            if (!this.options.culture) {
                this.options.culture = this.options.innerState._culture;
            }

            // map server properties to wijgrid **
            _super.prototype._init.apply(this, arguments);
        };

        c1gridview.prototype._create = function () {
            var self = this, topmost = this._topmostElement().removeClass("wijmo-wijgrid");

            this.options._aspNetDisabledClass = this.options.innerState._dc || "aspNetDisabled";

            this.mHasInitialWidth = topmost[0].style.width && (topmost[0].style.width !== "auto");

            this.mCallbackAction = c1.gridview.enumConverter.fromString(c1.gridview.callbackAction, this.options.callbackSettings.action);

            if (this.options.innerState.scrollingState) {
                this.mScrollingState = this.options.innerState.scrollingState;
            }

            this.mMobileSafari = wijmo.grid.isMobileSafari();
            this.mInsertNewRow = false;

            _super.prototype._create.apply(this, arguments);

            this.mAdjustHeaderText = false;

            // duplicate of the original table, used for cloning attributes and styles of cells and rows (server-side styles).
            this.mClonedTable = this.element.clone(false)[0];

            this.mFirstEditedRowIndex = -1;

            // localize filters display names if available.
            if (this.options.innerState._filterDisplayNames) {
                this._localizeFilterOperators(this.options.innerState._filterDisplayNames);
            }

            this.mHasDetails = !!this.options.innerState._hd;
            this.mCallbackInProgress = false;
            this.mTemplateCellsHandled = false;
        };

        c1gridview.prototype._callbackAction = function () {
            return this.mCallbackAction;
        };

        c1gridview.prototype._testCallback = function (action) {
            return ((this._callbackAction() & action) !== 0 /* none */);
        };

        c1gridview.prototype._topmostElement = function () {
            return this.element.closest("." + c1gridview.C1GridViewCss.marker);
        };

        c1gridview.prototype._originalHeaderRowData = function () {
            var header = this._tHead();

            if (header && header.length && this.options.showHeader) {
                var headerIdx = this.options.showFilter ? header.length - 2 : header.length - 1;

                if (headerIdx < header.length) {
                    return header[headerIdx];
                }
            }

            return null;
        };

        c1gridview.prototype._isServerSideEditRow = function (row) {
            var editIndex = this.options.innerState._bodyEditIndex;

            return !!row && (editIndex >= 0) && (row.dataItemIndex + this.mDataOffset === editIndex);
        };

        c1gridview.prototype._buildSketchRow = function (wrappedDataItem, leaves) {
            var meta = { value: null };

            if (wijmo.grid.dataViewWrapper.isHierarchyDetailItem(wrappedDataItem.values, meta)) {
                var ra = meta.value.rowAttributes, ca = meta.value.cellsAttributes, detailRow = new c1.gridview.SketchHierarchyDetailRow(wrappedDataItem.originalRowIndex, 1 /* rendering */, ra);

                for (var i = 0; i < leaves.length && (leaves[i] instanceof wijmo.grid.c1rowheaderfield); i++) {
                    detailRow.add(new wijmo.grid.ValueCell(null, {})); // append empty cells
                }

                $.each(wrappedDataItem.values, function (key, value) {
                    detailRow.add(new wijmo.grid.HtmlCell(value, (ca ? ca[key] : null) || {})); // append empy cells
                });

                return detailRow;
            } else {
                var sketchRow = _super.prototype._buildSketchRow.apply(this, arguments), isCollapsedHierarchyRow = wijmo.grid.dataViewWrapper.testMetaForClass(meta && meta.value, c1gridview.C1GridViewCss.collapsedRow);

                if (isCollapsedHierarchyRow || wijmo.grid.dataViewWrapper.testMetaForClass(meta && meta.value, c1gridview.C1GridViewCss.expandedRow)) {
                    sketchRow.rowType |= 256 /* dataHeader */;

                    if (isCollapsedHierarchyRow) {
                        sketchRow.extInfo.state |= 2 /* collapsed */;
                    }
                }

                return sketchRow;
            }
        };

        c1gridview.prototype._cloneNode = function (src) {
            var result = src.cloneNode(false), child;

            while (child = src.firstChild) {
                result.appendChild(child);
            }

            return result;
        };

        c1gridview.prototype._moveContent = function (src, dst) {
            if (src && dst) {
                while (dst.firstChild) {
                    dst.removeChild(dst.firstChild);
                }

                while (src.firstChild) {
                    dst.appendChild(src.firstChild);
                }
            }
        };

        c1gridview.prototype._onViewCreateEmptyCell = function (rowInfo, dataCellIndex, column) {
            var rt = wijmo.grid.rowType, opt = column.options;

            if (!this.mInsertNewRow && (dataCellIndex >= 0 || rowInfo.type === 1 /* header */)) {
                // move content from the original table to a new one during the first rendering only.
                var columnHeadersTable, cell, tmp, tableSection;

                switch (rowInfo.type & ~(4 /* dataAlt */ | 512 /* dataDetail */ | 256 /* dataHeader */)) {
                    case 1 /* header */:
                        tableSection = this.mClonedTable.tHead;

                        // clone the original header cell (to support header templates)
                        if (tableSection && (tmp = tableSection.rows[opt._thY]) && (tmp = tmp.cells[opt._thX2])) {
                            return $(tmp).clone()[0];
                        }

                        break;

                    case 8 /* filter */:
                        tableSection = this.mClonedTable.tHead;
                        if (tableSection && (tmp = tableSection.rows[tableSection.rows.length - 1]) && (tmp = tmp.cells[dataCellIndex])) {
                            return tmp.cloneNode(false);
                        }
                        break;

                    case 2 /* data */:
                        if (this.options.allowCustomContent) {
                            if (tableSection = this.mClonedTable.tBodies) {
                                tableSection = tableSection[0];
                            }

                            if (tableSection && (tmp = tableSection.rows[rowInfo.dataItemIndex]) && (tmp = tmp.cells[dataCellIndex])) {
                                return this._cloneNode(tmp);
                            }
                        }

                        break;

                    case 64 /* footer */:
                        tableSection = this.mClonedTable.tFoot;

                        if (tableSection && (tmp = tableSection.rows[0]) && (tmp = tmp.cells[dataCellIndex])) {
                            return this._cloneNode(tmp);
                        }

                        break;
                }
            }

            // groupFooter, groupHeader, banded row header, or C1GridView is not bounded to any data.
            return _super.prototype._onViewCreateEmptyCell.apply(this, arguments);
        };

        c1gridview.prototype._onViewCellRendered = function (cell, container, row, cellIndex, column) {
            if (row.type & 2 /* data */) {
                var opt = column.options, htmlContent = (row.data.html && row.data.html[opt.dataKey]) || null;

                if (row.type & 512 /* dataDetail */) {
                    if (cellIndex === this._virtualLeaves().length + 1) {
                        htmlContent = null;
                    }
                }

                if (htmlContent) {
                    if (!(column instanceof c1.gridview.c1gridviewtemplatefield)) {
                        var isEditRow = this._isServerSideEditRow(row), isC1Editor = this.options.allowC1InputEditors === true;

                        if (isEditRow && (htmlContent !== row.data[opt.dataKey]) && ((isC1Editor && !this.mRenderCounter) || (!isC1Editor && column.options.applyFormatInEditMode))) {
                            if (!isC1Editor) {
                                var formattedValue = this.toStr(opt, row.data[opt.dataKey]);
                                var regularEditor = container.find(":input");

                                if (!regularEditor.length && htmlContent) {
                                    container.html(htmlContent); // update content with a raw html
                                    regularEditor = container.find(":input");
                                }

                                container.find(":input").val(formattedValue);
                            } else {
                                // do nothing
                            }
                        } else {
                            if (isEditRow && isC1Editor) {
                                // 79648, 79165: child controls are initialized first, so htmlContent contains not original markup, but the one when C1Input has been initialized already. Use original markup instead.
                                var serverSideMarkup = this._getC1InplaceEditorMarkup(column);
                                if (serverSideMarkup) {
                                    htmlContent = serverSideMarkup;
                                }
                            }

                            container.html(htmlContent); // update content with a raw html
                        }
                    } else {
                        if (this.mRenderCounter > 0) {
                            container.html(htmlContent);
                        }
                    }
                }
            }

            _super.prototype._onViewCellRendered.apply(this, arguments);
        };

        c1gridview.prototype._onViewInsertEmptyRow = function (rowType, renderState, sectionRowIndex, dataRowIndex, dataItemIndex, virtualDataItemIndex, sketchRowIndex, groupByValue) {
            var domRow, columnHeadersTable, tableSection, rt = wijmo.grid.rowType;

            if (!this.mInsertNewRow && this.mRenderCounter === 0) {
                switch (rowType & ~(4 /* dataAlt */ | 512 /* dataDetail */ | 256 /* dataHeader */)) {
                    case 1 /* header */:
                        columnHeadersTable = this._columnsHeadersTable();

                        if (sectionRowIndex === columnHeadersTable.length - 1) {
                            if (tableSection = this.mClonedTable.tHead) {
                                domRow = tableSection.rows[0];
                            }
                        }

                        break;

                    case 8 /* filter */:
                        if (tableSection = this.mClonedTable.tHead) {
                            domRow = tableSection.rows[tableSection.rows.length - 1]; // last header row;
                        }

                        break;

                    case 2 /* data */:
                        domRow = this.mClonedTable.tBodies[0].rows[dataItemIndex];
                        break;

                    case 64 /* footer */:
                        if (tableSection = this.mClonedTable.tFoot) {
                            domRow = tableSection.rows[0];
                        }

                        break;
                }
            }

            tableSection = null;

            return (domRow) ? domRow.cloneNode(false) : _super.prototype._onViewInsertEmptyRow.apply(this, arguments);
        };

        c1gridview.prototype._onViewRowRendered = function (rowInfo, rowAttr, rowStyle) {
            _super.prototype._onViewRowRendered.apply(this, arguments);

            var className;

            if (rowAttr && (className = rowAttr["class"])) {
                if (className.indexOf(c1gridview.C1GridViewCss.selectedRow) >= 0) {
                    rowInfo.$rows.addClass(this.options.wijCSS.stateHighlight); // provide a default style for the server-side selected row
                }

                if (this.options.innerState._cbEditRowInitScript && (className.indexOf(c1gridview.C1GridViewCss.editRow) >= 0)) {
                    eval(this.options.innerState._cbEditRowInitScript); // initialize c1input editors during partial callback or virtual scrolling
                }
            }

            if (rowInfo.type & 512 /* dataDetail */) {
                var cnt = wijmo.grid.rowAccessor.cellsCount(rowInfo.$rows), detailCell = wijmo.grid.rowAccessor.getCell$(rowInfo.$rows, cnt - 1);

                detailCell.attr("colspan", this._visibleLeaves().length - cnt + 1);
            }
        };

        c1gridview.prototype._render = function () {
            _super.prototype._render.apply(this, arguments);

            this.element.closest("#" + this.element[0].id + "_div").removeClass("ui-helper-hidden-accessible");
        };

        c1gridview.prototype._createGroupAreaColumnHeader = function (element, column) {
            return new c1.gridview.c1gridviewgroupedfield(this, column.options, element);
        };

        c1gridview.prototype._allowHVirtualScrolling = function () {
            var result = _super.prototype._allowHVirtualScrolling.apply(this, arguments);
            return result && !this._hasDetails();
        };

        c1gridview.prototype._serverSideVirtualScrolling = function () {
            return this._allowVVirtualScrolling() && this._testCallback(512 /* scrolling */);
        };

        c1gridview.prototype._batchValues = function () {
            if (!this.mBatchValues) {
                this.mBatchValues = new c1.gridview.batchValues(this);
            }

            return this.mBatchValues;
        };

        c1gridview.prototype._needToCreatePagerItem = function () {
            return (this.options.pagerSettings.visible === true) && _super.prototype._needToCreatePagerItem.apply(this, arguments);
        };

        c1gridview.prototype._rebuildLeaves = function () {
            _super.prototype._rebuildLeaves.apply(this, arguments);

            // no header - clear span table
            if (!this.options.showHeader) {
                this._columnsHeadersTable([]);
            }
        };

        c1gridview.prototype._onLeavesCreated = function () {
            var _this = this;
            if (!this.mTemplateCellsHandled) {
                var leaves = this._leaves(), srcTable = this.element[0], dstTable = this.mClonedTable, editIndex = this.options.innerState._bodyEditIndex;

                // * Move child elements of the row being edited to clonedTable. *
                if (this.options.allowC1InputEditors && (editIndex >= 0)) {
                    var srcBody = srcTable.tBodies[0], dstBody = dstTable.tBodies[0], rowIndex = editIndex - this.mDataOffset, srcRow = srcBody.rows[rowIndex];

                    if (srcRow) {
                        $.each(leaves, function (idx, column) {
                            var opt = column.options;

                            if (!(column instanceof c1.gridview.c1gridviewtemplatefield)) {
                                var srcCell = srcRow.cells[opt.dataKey], dstCell = dstBody.rows[rowIndex].cells[opt.dataKey];

                                _this._moveContent(srcCell, dstCell);
                            }
                        });
                    }
                }

                // * Move child elements from the template column cells of the original table to clonedTable. *
                var tmplLeaves = [];

                $.each(leaves, function (idx, column) {
                    if (column instanceof c1.gridview.c1gridviewtemplatefield) {
                        tmplLeaves.push(column);
                    }
                });

                if (this._hasDetails() || tmplLeaves.length) {
                    for (var i = 0, srcRow; srcRow = srcTable.rows[i]; i++) {
                        if (srcRow.className.indexOf(wijmo.grid.wijgrid.CSS.emptyDataRow) >= 0) {
                            continue;
                        }

                        var dstRow = dstTable.rows[i];

                        if (this._hasDetails() && (srcRow.className.indexOf(wijmo.grid.wijgrid.CSS.detailRow) >= 0)) {
                            for (var j = 0; j < srcRow.cells.length; j++) {
                                this._moveContent(srcRow.cells[j], dstRow.cells[j]);
                            }
                        } else {
                            if (tmplLeaves.length) {
                                $.each(tmplLeaves, function (_, leaf) {
                                    var dataKey = leaf.options.dataKey;
                                    _this._moveContent(srcRow.cells[dataKey], dstRow.cells[dataKey]);
                                });
                            }
                        }
                    }
                }

                this.mTemplateCellsHandled = true;
            }

            _super.prototype._onLeavesCreated.apply(this, arguments);
        };

        c1gridview.prototype._needParseColumnDOM = function (column) {
            return _super.prototype._needParseColumnDOM.call(this, column) || (column._clientType === "c1templatefield");
        };

        c1gridview.prototype._getDOMReaderCulture = function () {
            return Globalize.findClosestCulture("en");
        };

        /** @ignore */
        c1gridview.prototype.parseCtx = function (column, value, dataItem, cell, forcedCulture) {
            if (cell && column._clientType === "c1templatefield") {
                dataItem.html = dataItem.html || {};
                dataItem.html[column.dataKey] = value; // store original content to use it during cell rendering (value == cell.innerHTML)

                return wijmo.grid._getDOMText(cell);
            }

            return this.parse.apply(this, [column, value, forcedCulture]);
        };

        /** @ignore */
        c1gridview.prototype.parseCtxFailed = function (column, value, dataItem, cell, forcedCulture) {
            var newValue;

            dataItem.html = dataItem.html || {}; // contains original content of the cells that can't be parsed.

            if (cell) {
                var dataAttr = cell.getAttribute("wijgrid-data"), newValue = (dataAttr || (dataAttr === "")) ? this._castValue(column, dataAttr) : this._castValue(column, wijmo.grid._getDOMText(cell, 3, column._clientType === "c1checkboxfield"));

                if (!isNaN(newValue) && (column.dataType === "datetime") && this.mMobileSafari) {
                    // get rid of iOS phone format detection: 123456789012 -> <a href="tel:123456789012">123456789012</a>
                } else {
                    dataItem.html[column.dataKey] = cell.innerHTML; // save original content for later use
                }

                newValue = wijmo.grid.isNaN(newValue) ? value : newValue;
            }

            return newValue;
        };

        /** @ignore */
        c1gridview.prototype.parse = function (column, value, forcedCulture) {
            var culture = forcedCulture || this._closestCulture(), parser = this._getDataParser(column), result = parser.parse(value, culture, this._getDefaultDataFormatString(column), this.options.nullString || "", true);

            if (wijmo.grid.isNaN(result)) {
                result = this._castValue(column, value);
            }

            return result;
        };

        /** @ignore */
        c1gridview.prototype.toStr = function (column, value, forcedCulture) {
            var culture = forcedCulture || this._closestCulture(), parser = this._getDataParser(column);

            return parser.toStr(value, culture, this._getDefaultDataFormatString(column), this.options.nullString || "", true);
        };

        c1gridview.prototype._addVirtualColumns = function (columns) {
            _super.prototype._addVirtualColumns.apply(this, arguments); // append rowHeader

            if (this._hasDetails()) {
                columns.push(c1.gridview.c1detailheaderfield.getInitOptions());
            }
        };

        c1gridview.prototype._prepareColumnsStage1 = function (columns, dataLoaded, finalStage) {
            if (dataLoaded && finalStage) {
                if (this.options.autoGenerateDeleteButton || this.options.autoGenerateEditButton || this.options.autoGenerateSelectButton || this.options.autoGenerateFilterButton) {
                    columns.splice(0, 0, wijmo.grid.createDynamicField({ innerState: { clientType: "c1commandfield" } }));
                }

                if (this.options.innerState && this.options.innerState.autogeneratedColumns) {
                    for (var i = 0, len = this.options.innerState.autogeneratedColumns.length; i < len; i++) {
                        var tmp = wijmo.grid.createDynamicField(this.options.innerState.autogeneratedColumns[i]);
                        columns.push(tmp);
                    }
                }
            }

            _super.prototype._prepareColumnsStage1.apply(this, arguments);
        };

        c1gridview.prototype._prepareColumnsStage2 = function (columns, generationMode, fieldsInfo, dataLoaded, finalStage, generateInstances) {
            if (typeof generateInstances === "undefined") { generateInstances = true; }
            if (dataLoaded && finalStage) {
                var dataKey = 0;

                wijmo.grid.traverse(columns, function (column) {
                    // map columns to DOMTable columns
                    if (column._isLeaf) {
                        column.dataKey = dataKey++;
                    }
                });
            }

            wijmo.grid.traverse(columns, function (column) {
                var innerState = column.innerState;

                // extract clientType
                if (innerState && innerState.clientType) {
                    column._clientType = innerState.clientType.split(":")[0].toLowerCase();
                }
            });

            _super.prototype._prepareColumnsStage2.apply(this, arguments);
        };

        c1gridview.prototype._hasDetails = function () {
            return this.mHasDetails;
        };

        c1gridview.prototype._isRootGridView = function () {
            return !!(this.options.innerState && this.options.innerState._root);
        };

        c1gridview.prototype._getRoot = function () {
            if (this._isRootGridView()) {
                return this;
            } else {
                var root = this._parent();

                while (root._parent()) {
                    root = root._parent();
                }

                return root;
            }
        };

        c1gridview.prototype._getFullPath = function () {
            if (this._isRootGridView()) {
                return "";
            } else {
                var path = [], current = this;

                do {
                    path.unshift(current.options.path);
                } while((current = current._parent()) && !current._isRootGridView());

                return path.join("-");
            }
        };

        c1gridview.prototype.detailGrids = function () {
            if (this._hasDetails() && !this._detailGrids && this._view()) {
                var rows = this._rows(), view = this._view(), len = rows.length();

                if (len) {
                    this._detailGrids = [];
                    var dataRowCnt = -1;

                    for (var i = 0; i < rows.length(); i++) {
                        var row = view._getRowInfo(rows.item(i), false);

                        if (row.type & 512 /* dataDetail */) {
                            var childGrid = row.$rows.find("." + wijmo.grid.wijgrid.CSS.root).eq(0);
                            if (childGrid.length) {
                                var instance = childGrid.data("wijmo-" + c1.c1detailgridview.prototype.widgetEventPrefix);

                                instance.options.path = dataRowCnt;

                                this._detailGrids.push(instance);
                            }
                        } else {
                            if (row.type & 2 /* data */) {
                                dataRowCnt++;
                            }
                        }
                    }
                }
            }

            return this._detailGrids || [];
        };

        c1gridview.prototype._resetDetailGrids = function () {
            var _this = this;
            if (this._detailGrids) {
                $.each(this._detailGrids, function (_, d) {
                    d.options.path = undefined;
                });
            }

            this._detailGrids = null;

            // restore parents
            if (this._hasDetails()) {
                $.each(this.detailGrids(), function (idx, detail) {
                    detail._parent(_this);
                });
            }
        };

        c1gridview.prototype._parent = function (value) {
            if (arguments.length) {
                this.mParent = value;
            }

            return this.mParent;
        };

        c1gridview.prototype._findDetailByPath = function (path) {
            var result = null;

            $.each(this.detailGrids(), function (_, d) {
                if (d.options.path === path) {
                    result = d;
                    return true;
                }
            });

            return result;
        };

        c1gridview.prototype._setSizeInternal = function (scrollValue, rowsToAdjust, resizeDetails) {
            if (typeof resizeDetails === "undefined") { resizeDetails = true; }
            // #43727 (c1gridview placed inside the c1superpanel)
            var topmost = this._topmostElement();

            if (!this.mHasInitialWidth) {
                topmost.width("");
            }

            _super.prototype._setSizeInternal.apply(this, arguments);

            if (!this.mHasInitialWidth) {
                topmost.css("width", this._view().getInlineTotalWidth() || ""); // set absolute width
            }

            if (this.options.innerState._hd && resizeDetails) {
                var details = this.detailGrids();
                for (var i = 0; i < details.length; i++) {
                    details[i]._ignoreSizing(false);
                    details[i].setSize();
                    details[i]._ignoreSizing(true);
                }
            }
        };

        c1gridview.prototype._onAfterCellUpdate = function (args) {
            if (this.mFirstEditedRowIndex === -1) {
                this.mFirstEditedRowIndex = args.cell.rowIndex();
            }

            _super.prototype._onAfterCellUpdate.apply(this, args);
        };

        c1gridview.prototype._onColumnDropping = function (args) {
            if (_super.prototype._onColumnDropping.apply(this, arguments)) {
                var dragState = args.drag.innerState, dropState = args.drop.innerState, params = [
                    "move",
                    dragState._uid,
                    dropState._uid,
                    args.at
                ];

                if (this._testCallback(1 /* colMove */)) {
                    this._doCallback(params);
                } else {
                    this._doPostBack(params);
                }
            }

            return false;
        };

        c1gridview.prototype._onColumnGrouping = function (args) {
            if (_super.prototype._onColumnGrouping.apply(this, arguments)) {
                var dragState = args.drag.innerState, dropState = args.drop && args.drop.innerState, params = [
                    "group",
                    dragState._uid,
                    args.drag.groupedIndex !== undefined ? args.drag.groupedIndex : -1,
                    args.drop ? dropState._uid : -1,
                    args.drop ? args.drop.groupedIndex : -1, args.at
                ];

                if (this._testCallback(256 /* grouping */)) {
                    this._doCallback(params);
                } else {
                    this._doPostBack(params);
                }
            }

            return false;
        };

        c1gridview.prototype._onColumnUngrouping = function (args) {
            if (_super.prototype._onColumnUngrouping.apply(this, arguments)) {
                var params = ["ungroup", args.column.innerState._uid];

                if (this._testCallback(256 /* grouping */)) {
                    this._doCallback(params);
                } else {
                    this._doPostBack(params);
                }
            }

            return false;
        };

        c1gridview.prototype._onColumnFiltering = function (args) {
            if (_super.prototype._onColumnFiltering.apply(this, arguments)) {
                if ((args.column.dataType === "datetime") && (args.value instanceof Date)) {
                    args.value = c1.gridview.truncDateTime(args.value, args.column.dataFormatString);
                }

                var innerState = args.column.innerState;

                //Encode filterValue if column is of string dataType.
                if (args.value && !args.column.dataType) {
                    innerState.newFilterValue = c1common.htmlEncode(args.value);
                } else {
                    innerState.newFilterValue = args.value;
                }
                innerState.newFilterOperator = args.operator;

                if (this.options.filterSettings.filterOnSelect) {
                    var params = ["filter", 0];

                    if (this._testCallback(128 /* filtering */)) {
                        this._doCallback(params);
                    } else {
                        this._doPostBack(params);
                    }
                }
            }

            return false;
        };

        c1gridview.prototype._onColumnSorting = function (args) {
            if (_super.prototype._onColumnSorting.apply(this, arguments)) {
                var column = this._allColumns()[args.column._travIdx];

                if (column._isSortable()) {
                    var params = [
                        "sort",
                        column.options.innerState._uid,
                        column.options.sortExpression
                    ];

                    if (this._testCallback(32 /* sorting */)) {
                        this._doCallback(params);
                    } else {
                        this._doPostBack(params);
                    }
                }
            }

            return false;
        };

        c1gridview.prototype._onCurrentCellChanged = function () {
            _super.prototype._onCurrentCellChanged.apply(this, arguments);

            if (this.options.clientEditingUpdateMode === "autoRowEdit" && this.mFirstEditedRowIndex >= 0 && this.mFirstEditedRowIndex !== this.currentCell().rowIndex()) {
                this.mFirstEditedRowIndex = -1;
                this.update();
            }
        };

        c1gridview.prototype._onPageIndexChanging = function (args) {
            if (_super.prototype._onPageIndexChanging.apply(this, arguments)) {
                var params = ["page", args.newPageIndex];

                if (this._testCallback(8 /* paging */)) {
                    this._doCallback(params);
                } else {
                    this._doPostBack(params);
                }
            }

            return false;
        };

        c1gridview.prototype._onBatchUpdate = function (args) {
            var params = ["batch"];

            this.options.batchValues = args.value;

            if (this._testCallback(2 /* editing */)) {
                this._doCallback(params);
            } else {
                this._doPostBack(params);
            }
        };

        c1gridview.prototype._onToggleHierarchy = function (e, row) {
            if (this._canInteract()) {
                var params = ["hierarchy", row.$rows.attr("id")];

                if (this._testCallback(1024 /* hierarchy */)) {
                    this._doCallback(params);
                } else {
                    this._doPostBack(params);
                }
            }
        };

        c1gridview.prototype._postset_allowClientEditing = function (value, oldValue) {
            this._setOption("editingMode", value ? "cell" : "none"); // update wijgrid.editingMode option.
        };

        c1gridview.prototype._postset_clientSelectionMode = function (value, oldValue) {
            this._setOption("selectionMode", value); // update wijgrid.selectionMode option.
        };

        c1gridview.prototype._postset_displayVisible = function (value, oldValue) {
            if (value) {
                this.element.show();
                this._topmostElement().show();
                this.setSize();
            } else {
                this._topmostElement().hide();
                this.element.hide();
            }
        };

        c1gridview.prototype._postset_showClientSelectionOnRender = function (value, oldValue) {
            this._setOption("showSelectionOnRender", value); // update wijgrid.showSelectionOnRender option.
        };

        c1gridview.prototype._postset_selectedIndex = function (value, oldValue) {
            var params = ["select", value];

            if (this._testCallback(16 /* selection */)) {
                this._doCallback(params);
            } else {
                this._doPostBack(params);
            }
        };

        c1gridview.prototype.onwijstatesaving = function () {
            var tmp = $.extend(true, {}, this.options), simplify = function (item) {
                var key, value;
                for (key in item) {
                    if (item.hasOwnProperty(key)) {
                        value = item[key];

                        if ((value === null) || (value === undefined) || (typeof (value) === "function") || ((key + "").indexOf("_") === 0) || (key === "data") || (key === "dataParser") || (key === "expandInfo") || (key === "wijCSS") || (key === "wijMobileCSS")) {
                            delete item[key];
                        } else {
                            if ($.isPlainObject(value) || $.isArray(value)) {
                                simplify(value);
                            }
                        }
                    }
                }
            };

            // remove dynamic columns first (simplify will remove all underscored properties)
            tmp.columns = $.grep(tmp.columns, function (column, _) {
                return !column._dynamic;
            });

            // remove redundant properties
            simplify(tmp);

            return tmp;
        };

        c1gridview.prototype._castValue = function (column, value) {
            var foo;

            switch (column.dataType) {
                case "number":
                case "currency":
                    value = parseFloat(value);
                    break;

                case "datetime":
                    foo = value * 1;

                    if (isNaN(foo)) {
                        value = new Date(value);

                        if (!wijmo.grid.validDate(value)) {
                            value = NaN;
                        }
                    } else {
                        var offset = new Date(foo).getTimezoneOffset() * 60000;
                        value = new Date(foo + offset); // foo is a timestamp (server timezone, utc + server offset) => (utc + server offset) + local offset - local offset === server datetime (#39285).
                    }

                    break;

                case "boolean":
                    foo = value.toLowerCase();
                    if (foo === "true" || foo === "false") {
                        value = (foo === "true");
                    } else {
                        value = NaN;
                    }

                    break;
            }

            return value;
        };

        c1gridview.prototype._onBeforeCallback = function (argument) {
            var args = argument.split(":"), result = "";

            if (args.length && args[0].toLowerCase() === "update") {
                var values = this._onBeforeUpdateCmdCallback(this.mOuterDiv.find("tr." + c1gridview.C1GridViewCss.editRow));
                result = c1common.JSON.stringify(values || []);
            }

            return result;
        };

        c1gridview.prototype._doCallback = function (argumentsArray, contextParam) {
            this._encodeFilterValues();
            var id = this.options.innerState._cid;

            new c1.gridview.cbp(id || "", argumentsArray.join(":"), contextParam);
        };

        c1gridview.prototype._doPostBack = function (argumentsArray) {
            this._encodeFilterValues();
            var params = wijmo.grid.stringFormat(this.options.innerState._pbRef, argumentsArray.join(":"));

            if (!window.event) {
                // Workaround for an ASP.NET 4 issue: Sys$WebForms$PageRequestManager$_doPostBack function is trying to access arguments.callee if window.event is undefined.
                // Access to arguments.caller\ arguments.callee throw an exception when "strict mode" is used.
                window.event = {
                    target: null,
                    srcElement: null
                };
            }

            eval(params);
        };

        c1gridview.prototype._encodeFilterValues = function () {
            var columns = this.columns(), filterValue;
            for (var i = 0; i < columns.length; i++) {
                filterValue = columns[i].option("filterValue");
                if (filterValue && !columns[i].option("dataType")) {
                    columns[i].option("filterValue", c1common.htmlEncode(filterValue));
                }
            }
        };

        c1gridview.prototype._getC1InplaceEditorMarkup = function (column) {
            if (column) {
                var gi = this.options.innerState, ci = column.options.innerState;

                if (gi && ci) {
                    var markup = gi._c1InplaceEditorsMarkup;

                    if (markup && markup[ci._uid]) {
                        return wijmo.htmlDecode(markup[ci._uid]);
                    }
                }
            }

            return null;
        };

        c1gridview.prototype._getDefaultDataFormatString = function (column) {
            if (!column.dataFormatString) {
                if (column.dataType === "datetime" && column.dataTypeQualifier === "timespan") {
                    return "T";
                }

                if (column.dataType === "number" && !column.dataTypeQualifier) {
                    return "n0";
                }
            }

            return column.dataFormatString;
        };

        c1gridview.prototype._onBeforeUpdateCmdCallback = function ($row) {
            var view = this._view(), rowIndex = view.getAbsoluteRowIndex($row[0]), values = [], self = this, getEditorValue = function (domCell, cellIndex, param) {
                $(domCell).find(":input").each(function (index, element) {
                    if (element.type === "hidden") {
                        return true;
                    }

                    var $editor = $(element), value = self._getEditorValue($editor);

                    if (value !== undefined) {
                        name = $editor.attr("name") || $editor.attr("id");
                        if (name) {
                            param.push([name.replace(/_/g, "$"), value]);
                        }
                    }
                });

                return true;
            };

            view.forEachRowCell(rowIndex, getEditorValue, values);

            getEditorValue = null;

            return values;
        };

        c1gridview.prototype._getEditorValue = function ($editor) {
            var result = null, data = $editor.data(), widgetName;

            if (data && (widgetName = data["widgetName"])) {
                var instance = $editor.data("wijmo-" + widgetName);

                if (instance) {
                    if (instance instanceof $.wijmo.wijinputnumber) {
                        return instance.options.value;
                    }

                    if (instance instanceof $.wijmo.wijinputdate) {
                        return instance.options.date;
                    }

                    if ((instance instanceof $.wijmo.wijinputtext) || (instance instanceof $.wijmo.wijinputmask)) {
                        return instance.options.text;
                    }
                }
            }

            return $editor.is(":checkbox") ? $editor.is(":checked") : $editor.val();
        };

        c1gridview.prototype._processingPartialCallback = function () {
            return this.mInsertNewRow;
        };

        c1gridview.prototype._updateUnderlyingInfo = function (sketchStartIndex, rowStartIndex, delta) {
            for (var i = sketchStartIndex, len = this.mSketchTable.count(); i < len; i++) {
                var row = this.mSketchTable.row(i);

                if (row instanceof wijmo.grid.SketchDataRow) {
                    row.originalRowIndex += delta;
                }
            }

            var rows = this._rows(), view = this._view();

            for (var i = rowStartIndex, len = rows.length(); i < len; i++) {
                var rowInfo = view._getRowInfo(rows.item(i));

                rowInfo.sectionRowIndex += delta;

                if (rowInfo.type & 2 /* data */) {
                    rowInfo.dataItemIndex += delta;
                    rowInfo.dataRowIndex += delta;
                    rowInfo.virtualDataItemIndex += delta;
                    rowInfo.sketchRowIndex += delta;
                }

                view._setRowInfo(rowInfo.$rows, rowInfo);
            }
        };

        c1gridview.prototype._handleHierarchyCallback = function (entity, params) {
            var foo = document.createElement("div");

            foo.innerHTML = "<table>" + entity.html + "</table>";
            foo = (foo.getElementsByTagName("table")[0]);

            var body = wijmo.grid.getTableSection(foo, 2 /* body */), data = this._readTableSection(foo, 2 /* body */, true), dataIndex = entity.rowIndex - this.mDataOffset, currentCell = this.currentCell()._clone();

            // after the new row will be inserted (or deleted) the current cell and selection object cells are become invalid. so clear them first.
            this._changeCurrentCell(null, new wijmo.grid.cellInfo(-1, -1, null, false, false), { changeSelection: true });

            var view = this._view(), leaves = this._leaves(), opts = this._instancesToOptions(leaves), dvw = this.mDataViewWrapper, row = view.bodyRows().find(entity.rowIndex, function (row) {
                return row.dataItemIndex === entity.rowIndex;
            }, false), sketchRowIndex = this.mSketchTable.findIndex(dataIndex, function (row) {
                return row.isDataRow() && row.originalRowIndex === dataIndex;
            });

            for (var i = 0; i < (entity.expand ? 1 : 2); i++) {
                view._removeBodyRow(row.sectionRowIndex);
                this.mSketchTable.remove(sketchRowIndex);
                dvw._unsafeSplice(dataIndex, 1);
            }

            // parse
            dvw._parseOwnData(data, opts, body);

            for (var i = 0; i < data.length; i++) {
                var sketchRow = this._buildSketchRow(dvw._wrapDataItem(data[i], dataIndex + i), leaves);

                dvw._unsafeSplice(dataIndex + i, 0, data[i]);
                this.mSketchTable.insert(sketchRowIndex + i, sketchRow);

                this.mInsertNewRow = true;
                try  {
                    view._insertBodyRow(sketchRow, row.sectionRowIndex + i, row.dataItemIndex + i, row.virtualDataItemIndex + i, sketchRowIndex + i);
                } finally {
                    this.mInsertNewRow = false;
                }
            }

            if (entity.expand) {
                this._updateUnderlyingInfo(sketchRowIndex + 2, row.sectionRowIndex + 2, 1);
            } else {
                this._updateUnderlyingInfo(sketchRowIndex + 1, row.sectionRowIndex + 1, -1);
            }

            view._rebuildOffsets();
            view._ensureRenderBounds();
            this._rebuildRenderableRowsCollection();

            this._changeCurrentCell(null, currentCell, { changeSelection: true }); // restore current cell and selection
        };

        c1gridview.prototype._handlePartialCallback = function (entity, params) {
            var rowsAccessor = this._rows(), leaves = this._leaves(), opts = this._instancesToOptions(leaves), view = this._view(), allowVirtualScrolling = this._allowVVirtualScrolling(), dvw = this.mDataViewWrapper, sketchRow, invCulture = this._getDOMReaderCulture();

            for (var i = 0; i <= 1; i++) {
                var rowEntity = i ? entity.curRow : entity.prevRow;

                if (rowEntity.rowIndex >= 0) {
                    // * build DOM from response *
                    //foo = $("<table>" + json.response[i + 1] + "</table>")[0]; // issues with the "checked" attribute
                    var dataIndex = rowEntity.rowIndex - this.mDataOffset;

                    if (dataIndex < 0) {
                        continue;
                    }

                    var foo = document.createElement("div");
                    foo.innerHTML = "<table>" + rowEntity.html + "</table>";
                    foo = (foo.getElementsByTagName("table")[0]);

                    var rowData = this._readTableSection(foo, 2 /* body */, true);

                    // * update underlying data *
                    var newDataItem = wijmo.grid.dataViewWrapper._parseDataItem(this, rowData[0], foo.rows[0], opts, invCulture);
                    dvw._unsafeReplace(dataIndex, newDataItem); //  this.dataView().getSource() === newDataItem

                    var sketchRowIndex = this.mSketchTable.findIndex(dataIndex, function (row) {
                        return row.isDataRow() && row.originalRowIndex === dataIndex;
                    });

                    this.mSketchTable.replace(sketchRowIndex, sketchRow = this._buildSketchRow(dvw._wrapDataItem(newDataItem, dataIndex), leaves));

                    // update DOM *
                    // find rowInfo by dataItemIndex
                    var rowInfo = view.bodyRows().find(0, function (row) {
                        return row.dataItemIndex === dataIndex;
                    });

                    if (!rowInfo) {
                        if (!allowVirtualScrolling) {
                            throw "rowInfo is null";
                        }
                    } else {
                        view._removeBodyRow(rowInfo.sectionRowIndex); // remove old row

                        this.mInsertNewRow = true; // insert a new one
                        try  {
                            rowInfo = view._insertBodyRow(sketchRow, rowInfo.sectionRowIndex, rowInfo.dataItemIndex, rowInfo.virtualDataItemIndex, sketchRowIndex);
                            //if (rowEntity.initializationScript) {
                            //	eval(rowEntity.initializationScript);
                            //}
                        } finally {
                            this.mInsertNewRow = false;
                        }
                    }
                }
            }

            dvw._refreshSilent();
        };

        c1gridview.prototype._handleVirtualScrollingCallback = function (entity, param) {
            var _this = this;
            var foo = document.createElement("div"), leaves = this._leaves(), opts = this._instancesToOptions(leaves), rawData, newData = [], invCulture = this._getDOMReaderCulture();

            foo.innerHTML = "<table>" + entity.html + "</table>";
            foo = foo.firstChild; // foo.getElementsByTagName("table")[0];

            rawData = this._readTableSection(foo, 2 /* body */, true); // get raw (unparsed) data

            for (var i = 0; i < foo.rows.length; i++) {
                newData.push(wijmo.grid.dataViewWrapper._parseDataItem(this, rawData[i], foo.rows[i], opts, invCulture)); // parse
            }

            this.mInsertNewRow = true;
            try  {
                this.mDataViewWrapper.makeDirty();

                // fallback to wijgrid with a new data items
                // Renew the selection. When server-side vertical virtual scrolling is used the sketchTable contains only currently rendered rows (there is no "detached" rows covering all available rows in this case), so the _onRendered->_ensureSelection() method call fails to renew selection properly.
                if (this._serverSideVirtualScrolling()) {
                    var selectionMode = this.options.selectionMode.toLowerCase();
                    if (selectionMode === "singlecolumn" || selectionMode === "multicolumn") {
                        var originalCompleteCallback = param.completeCallback;

                        param.completeCallback = function () {
                            if (originalCompleteCallback) {
                                originalCompleteCallback.apply(_this, arguments);
                            }

                            _this._updateSelection(null, 0 /* none */);
                        };
                    }
                }
                _super.prototype._onVirtualScrolling.call(this, param.newBounds, param.request, param.mode, param.scrollIndex, param.completeCallback, newData);
                //if (entity.initializationScript) { // edit row was rendered into view, initialize child controls
                //	eval(entity.initializationScript);
                //}
            } finally {
                this.mInsertNewRow = false;
            }
        };

        c1gridview.prototype._instancesToOptions = function (instances) {
            var result = [];

            $.each(instances, function (_, value) {
                if (!(value instanceof wijmo.grid.c1rowheaderfield)) {
                    result.push(value.options);
                }
            });

            return result;
        };

        c1gridview.prototype._beginEditInternal = function (e) {
            var row = this.currentCell().row();
            if (row && (row.type & 512 /* dataDetail */)) {
                return false;
            }

            var success = _super.prototype._beginEditInternal.apply(this, arguments);

            if (success) {
                this._batchValues().addValue(this.currentCell());
            }

            return success;
        };

        c1gridview.prototype._endEditInternal = function (e) {
            var success = _super.prototype._endEditInternal.apply(this, arguments);

            if (success) {
                this._batchValues().addValue(this.currentCell());
            }

            return success;
        };

        /// <summary>
        /// Sends edits done by user to server in client editing mode.
        /// </summary>
        /// <remarks>
        /// Works only if the <see cref="allowClientEditing"/> option is set to True.
        /// </remarks>
        c1gridview.prototype.update = function () {
            if (this._allowCellEditing() && (this.endEdit() !== false)) {
                var batchValues = this._batchValues().simplify(), leaves = this._leaves(), data = this.data();

                this.mBatchValues = null; // clear

                if (batchValues) {
                    var values = {};

                    for (var key in batchValues) {
                        if (batchValues.hasOwnProperty(key)) {
                            values[key] = {};

                            $.each(leaves, function (_, leaf) {
                                if (leaf instanceof c1.gridview.c1gridviewboundfield) {
                                    var boundField = leaf, opt = boundField.options;

                                    if (!opt.readOnly && wijmo.grid.validDataKey(opt.dataField)) {
                                        if (batchValues[key][opt.dataField]) {
                                            values[key][opt.dataField] = batchValues[key][opt.dataField];
                                        } else {
                                            values[key][opt.dataField] = [data[key][opt.dataKey], data[key][opt.dataKey]];
                                        }
                                    }
                                }
                            });
                        }
                    }

                    this._onBatchUpdate({ value: values }); // sends all changed row's values (to enable automatic updating)
                }
            }
        };

        c1gridview.prototype.doFilter = function (headerText, filterExpression) {
            var column, opt, args, cols = this.columns().filter(function (col) {
                return col instanceof c1.gridview.c1gridviewtemplatefield && col.options.headerText == headerText;
            });
            if (cols.length > 0) {
                column = cols[0];
                column.options.filterExpression = filterExpression;
                opt = column.options;
                args = { column: opt, operator: "contains", value: "" };
                this._onColumnFiltering(args);
            }
        };

        c1gridview.prototype._onVirtualScrolling = function (newBounds, request, mode, scrollIndex, completeCallback) {
            if (request !== null) {
                this._doCallback(["vscroll", request.index + "", request.maxCount + ""], { newBounds: newBounds, request: request, mode: mode, scrollIndex: scrollIndex, completeCallback: completeCallback }); // request a new data page.
            } else {
                this.mInsertNewRow = true;
                try  {
                    _super.prototype._onVirtualScrolling.apply(this, arguments);
                } finally {
                    this.mInsertNewRow = false;
                }
            }
        };

        c1gridview.prototype._totalRowsCount = function () {
            if (this._serverSideVirtualScrolling()) {
                return this.options.totalRows;
            }

            return _super.prototype._totalRowsCount.apply(this, arguments);
        };

        c1gridview.prototype._trackScrollingPosition = function (x, y) {
            _super.prototype._trackScrollingPosition.apply(this, arguments);

            this.options.innerState.scrollingState = this.mScrollingState;
        };

        c1gridview.prototype._trackScrollingIndex = function (index) {
            _super.prototype._trackScrollingIndex.apply(this, arguments);

            this.options.innerState.scrollingState = this.mScrollingState;
        };
        c1gridview.C1GridViewCss = {
            selectedRow: "c1-c1gridview-selectedrow",
            editRow: "c1-c1gridview-editrow",
            expandedRow: "c1-c1gridview-expandedrow",
            collapsedRow: "c1-c1gridview-collapsedrow",
            marker: "c1gridview-marker"
        };
        return c1gridview;
    })(wijmo.grid.wijgrid);
    c1.c1gridview = c1gridview;

    c1gridview.prototype.widgetEventPrefix = "c1gridview";

    

    

    

    c1gridview.prototype.options = $.extend(true, {}, $.wijmo.wijgrid.prototype.options, {
        _htmlTrimMethod: 1 /* control */,
        columnsAutogenerationMode: "none",
        allowCustomContent: true,
        allowC1InputEditors: false,
        autoGenerateDeleteButton: false,
        autoGenerateEditButton: false,
        autoGenerateSelectButton: false,
        autoGenerateFilterButton: false,
        callbackSettings: {
            action: "none",
            mode: "partial"
        },
        clientEditingUpdateMode: "autoRowEdit",
        filterSettings: {
            filterOnSelect: true,
            mode: "auto"
        },
        innerState: {},
        pagerSettings: {
            visible: true
        },
        selectionMode: "none",
        selectedIndex: -1,
        showHeader: true,
        readAttributesFromData: true
    });

    $.wijmo.registerWidget("c1gridview", $.wijmo.wijgrid, c1gridview.prototype);
})(c1 || (c1 = {}));

var c1;
(function (c1) {
    (function (gridview) {
        var $ = jQuery;

        (function (callbackAction) {
            /// <summary>
            /// All actions are performed via postback.
            /// </summary>
            callbackAction[callbackAction["none"] = 0x0] = "none";

            /// <summary>
            /// Column moving is performed via callbacks.
            /// </summary>
            callbackAction[callbackAction["colMove"] = 0x01] = "colMove";

            /// <summary>
            /// Editing is performed via callbacks.
            /// </summary>
            callbackAction[callbackAction["editing"] = 0x02] = "editing";

            /// <summary>
            /// Paging is performed via callbacks.
            /// </summary>
            callbackAction[callbackAction["paging"] = 0x08] = "paging";

            /// <summary>
            /// Row selection is performed via callbacks.
            /// </summary>
            callbackAction[callbackAction["selection"] = 0x10] = "selection";

            /// <summary>
            /// Sorting is performed via callbacks.
            /// </summary>
            callbackAction[callbackAction["sorting"] = 0x20] = "sorting";

            /// <summary>
            /// Filtering is performed via callbacks.
            /// </summary>
            callbackAction[callbackAction["filtering"] = 0x80] = "filtering";

            /// <summary>
            /// Grouping is performed via callbacks.
            /// </summary>
            callbackAction[callbackAction["grouping"] = 0x100] = "grouping";

            /// <summary>
            /// Scrolling is performed via callbacks.
            /// </summary>
            callbackAction[callbackAction["scrolling"] = 0x200] = "scrolling";

            callbackAction[callbackAction["hierarchy"] = 0x400] = "hierarchy";

            /// <summary>
            /// All actions are performed via callbacks.
            /// </summary>
            callbackAction[callbackAction["all"] = 0x01 | 0x02 | 0x08 | 0x10 | 0x20 | 0x80 | 0x100 | 0x200 | 0x400] = "all";
        })(gridview.callbackAction || (gridview.callbackAction = {}));
        var callbackAction = gridview.callbackAction;

        /** @ignore */
        var batchValues = (function () {
            function batchValues(gridView) {
                this._rows = {};
                this._gridView = gridView;
            }
            batchValues.prototype.addValue = function (cellInfo) {
                if (cellInfo && cellInfo._isValid()) {
                    var value = cellInfo.value(), rowKey = cellInfo.rowIndex(), cellKey = cellInfo.cellIndex(), rowInfo;

                    if (rowInfo = this._rows[rowKey]) {
                        if (!rowInfo[cellKey]) {
                            rowInfo[cellKey] = {
                                initValue: value
                            };
                        }
                    } else {
                        rowInfo = this._rows[rowKey] = {};
                        rowInfo[cellKey] = {
                            initValue: value
                        };
                    }
                }
            };

            batchValues.prototype.simplify = function () {
                var rows = {};

                for (var rowKey in this._rows) {
                    if (this._rows.hasOwnProperty(rowKey)) {
                        var row = this._rows[rowKey], dataItemIndex = -1, values = {};

                        for (var cellKey in row) {
                            var cell = row[cellKey];
                            if (row.hasOwnProperty(cellKey) && (!wijmo.grid.isNaN(cell.initValue))) {
                                var cellInfo = new wijmo.grid.cellInfo(parseInt(cellKey, 10), parseInt(rowKey, 10));

                                cellInfo._setGridView(this._gridView);

                                if (dataItemIndex < 0) {
                                    dataItemIndex = cellInfo.row().dataItemIndex;
                                }

                                var actualDataValue = cellInfo.value();
                                if (cell.initValue !== actualDataValue) {
                                    var opt = cellInfo.column();
                                    values[opt.dataField] = [cell.initValue, actualDataValue];
                                }
                            }
                        }

                        if (!$.isEmptyObject(values) && dataItemIndex >= 0) {
                            rows[dataItemIndex] = values;
                        }
                    }
                }

                return ($.isEmptyObject(rows)) ? null : rows;
            };
            return batchValues;
        })();
        gridview.batchValues = batchValues;

        /** @ignore */
        var enumConverter = (function () {
            function enumConverter() {
            }
            enumConverter.fromString = function (enumObj, value) {
                var values = value.split(","), success = true, result = 0;

                for (var i = 0, len = values.length; i < len && success; i++) {
                    var cc = this._camelCase($.trim(values[i])), test;

                    if (success = ((test = enumObj[cc]) !== undefined)) {
                        result |= test;
                    }
                }

                return success ? result : undefined;
            };

            enumConverter.toString = function (enumObj, value) {
                if (enumObj[value] !== undefined) {
                    return enumObj[value];
                }

                var key, result = [];

                for (key in enumObj) {
                    if (enumObj.hasOwnProperty(key)) {
                        var numKey = parseInt(key, 10);

                        if (numKey !== undefined) {
                            if (value & numKey) {
                                value &= ~numKey;
                                result.push(enumObj[key]);
                            }
                        }
                    }
                }

                return (result.length && value === 0) ? result.join(", ") : undefined;
            };

            enumConverter._camelCase = function (value) {
                return (value && value.length) ? value.substring(0, 1).toLowerCase() + value.substring(1) : value;
            };
            return enumConverter;
        })();
        gridview.enumConverter = enumConverter;

        // dateTime utilites *
        /** @ignore */
        function truncDateTime(value, dataFormatString) {
            var timeUnits = wijmo.grid.TimeUnitConverter.convertFormatString(dataFormatString || "d");
            value = wijmo.grid.TimeUnitConverter.cutDate(value, timeUnits);

            return value;
        }
        gridview.truncDateTime = truncDateTime;

        /** @ignore */
        function dateToInvariantString(date) {
            if (date) {
                return date.format("MM/dd/yyyy");
            }

            return date;
        }
        gridview.dateToInvariantString = dateToInvariantString;
    })(c1.gridview || (c1.gridview = {}));
    var gridview = c1.gridview;
})(c1 || (c1 = {}));

var c1;
(function (c1) {
    (function (gridview) {
        var $ = jQuery;

        

        

        

        

        

        

        

        /** @ignore */
        var cbp = (function () {
            function cbp(gridID, argument, contextParam) {
                var _this = this;
                var source = this.getGridInstance(jQuery("#" + gridID));

                if (!source) {
                    throw "invalid id";
                }

                var root = source._getRoot();

                if (!source._canInteract() || !root._canInteract()) {
                    return;
                }

                var context = {
                    source: source,
                    root: root,
                    param: contextParam
                };

                this.callbackInProggress(context, true);

                argument = this.prepareArgument(argument, root, source);

                var prmi, doCallback = function () {
                    // root grid is ALWAYS acts as an eventTarget.
                    WebForm_DoCallback(root.options.innerState._uid, argument, $.proxy(_this.eventCallback, _this), context, $.proxy(_this.errorCallback, _this), true);
                };

                // An async postback is currently running by PageRequestManager. Wait until it will be completed otherwise the WebForm_DoCallback() function call will be omitted (#112510).
                if ((typeof (Sys) !== "undefined") && Sys.WebForms && Sys.WebForms.PageRequestManager && (prmi = Sys.WebForms.PageRequestManager.getInstance()) && prmi.get_isInAsyncPostBack()) {
                    var endRequestHandler = $.proxy(function () {
                        prmi.remove_endRequest(endRequestHandler);
                        doCallback.call(_this); // and run
                    }, this);

                    prmi.add_endRequest(endRequestHandler);
                } else {
                    doCallback.call(this); // run immediately
                }
            }
            // { command, mode, options, response }
            cbp.prototype.eventCallback = function (value, context) {
                try  {
                    var response = jQuery.parseJSON(value);

                    c1common.updateWebFormsInternals(context.source.options.innerState._cid, response.options); // response.options is a string here

                    if ((context.root !== context.source) && response.rootInnerState) {
                        context.root.options.innerState = jQuery.parseJSON(response.rootInnerState); // do not updateWebFormsInternals here. All callbacks are targeted to the root so _doCallback will call it automatically.
                    }

                    response.options = this.adjustFuncOptions(context, jQuery.parseJSON(response.options));

                    var view = context.source._view();
                    if (view && (view instanceof wijmo.grid.fixedView)) {
                        view.resetRowsHeightsCache();
                    }

                    if (response.mode === "partial") {
                        switch (response.command) {
                            case "vscroll":
                                this.handleVirtualScrollingCallback(response, context);
                                break;

                            case "hierarchy":
                                this.handleHierarchyCallback(response, context);
                                break;

                            default:
                                this.handlePartialCallback(response, context);
                                break;
                        }
                    } else {
                        this.handleFullCallback(response, context);
                    }
                } finally {
                    this.callbackInProggress(context, false);
                }
            };

            cbp.prototype.errorCallback = function (value, context) {
                try  {
                    alert(value);
                } finally {
                    this.callbackInProggress(context, false);
                }
            };

            cbp.prototype.handlePartialCallback = function (response, context) {
                var grid = context.source;

                grid.options.batchValues = null;

                if (response.command === "batch") {
                    return;
                }

                grid.options.editIndex = response.options.editIndex;
                grid.options.selectedIndex = response.options.selectedIndex;
                grid.options.innerState = response.options.innerState;

                try  {
                    grid.mPartialCallback = true;
                    grid._handlePartialCallback(response.entity, context.param);
                } finally {
                    grid.mPartialCallback = false;
                }
            };

            cbp.prototype.handleFullCallback = function (response, context) {
                var grid = context.source, $parentDiv = grid.element.closest("#" + context.source.options.innerState._cid + "_div"), entity = response.entity;

                $parentDiv.empty().html(entity.html);

                if (entity.initializationScript) {
                    eval(entity.initializationScript);
                }

                var table = $parentDiv.find("> table"), options = wijmoASPNetParseOptions(response.options);

                // create new widget
                if (grid instanceof $.wijmo.c1detailgridview) {
                    table.c1detailgridview(options);

                    // restore parent
                    var parent = grid._parent();
                    if (parent) {
                        parent._resetDetailGrids();

                        do {
                            parent._setSizeWithoutDetails();
                        } while(parent = parent._parent());
                    }
                } else {
                    table.c1gridview(options);
                }
            };

            cbp.prototype.handleHierarchyCallback = function (response, context) {
                var grid = context.source, entity = response.entity;

                try  {
                    grid.options.innerState = response.options.innerState; // store tree hierarachy state between callbacks

                    grid.mPartialCallback = true;
                    grid._handleHierarchyCallback(entity, context.param);
                    eval(entity.initializationScript);

                    grid._resetDetailGrids();

                    // recalculate sizes
                    var current = grid;
                    do {
                        current._setSizeWithoutDetails();
                    } while(current = current._parent());
                } finally {
                    grid.mPartialCallback = false;
                }
            };

            cbp.prototype.handleVirtualScrollingCallback = function (response, context) {
                var grid = context.source, entity = response.entity;

                grid.options.pageIndex = response.options.pageIndex;
                grid.options.selectedIndex = response.options.selectedIndex;
                grid.options.editIndex = response.options.editIndex;
                grid.options.innerState = response.options.innerState;

                try  {
                    grid.mPartialCallback = true;
                    grid._handleVirtualScrollingCallback(entity, context.param);
                } finally {
                    grid.mPartialCallback = false;
                }
            };

            cbp.prototype.adjustFuncOptions = function (context, options) {
                var test, grid = context.source;

                if (options && grid && grid._funcOptions && ($.isArray(test = grid._funcOptions()))) {
                    for (var key in options) {
                        if (options.hasOwnProperty(key)) {
                            if (($.inArray(key, test) !== -1) && (typeof (options[key]) === "string")) {
                                options[key] = window[options[key]] || options[key];
                            }
                        }
                    }
                }

                return options;
            };

            cbp.prototype.callbackInProggress = function (context, value) {
                context.source.mCallbackInProgress = value;
                context.root.mCallbackInProgress = value;

                if (value) {
                    context.source._activateSpinner();
                } else {
                    context.source._deactivateSpinner();
                }
            };

            cbp.prototype.prepareArgument = function (argument, root, source) {
                var extraArument = source._onBeforeCallback(argument);

                if (extraArument) {
                    argument += ":" + extraArument;
                }

                this.saveSettings(root);

                if (source !== root) {
                    this.saveSettings(source);

                    argument = "#" + c1.gridview.stringUtils.encodeValues([
                        argument,
                        "p" + source._getFullPath(),
                        __JSONC1.stringify(source.onwijstatesaving())
                    ]);
                }

                return argument;
            };

            cbp.prototype.saveSettings = function (grid) {
                grid.element.wijSaveState(grid.widgetName, "onwijstatesaving");
                c1common.updateWebFormsInternals(grid.options.innerState._cid, __JSONC1.stringify(grid.onwijstatesaving()));
            };

            cbp.prototype.getGridInstance = function (element) {
                if (element && element.length) {
                    return element.data("wijmo-c1gridview") || element.data("wijmo-c1detailgridview");
                }

                return null;
            };
            return cbp;
        })();
        gridview.cbp = cbp;

        /** @ignore */
        var stringUtils = (function () {
            function stringUtils() {
            }
            stringUtils.encodeValues = function (values) {
                var res = "";

                if (values) {
                    for (var i = 0; i < values.length; i++) {
                        res += values[i].length + "," + values[i];
                    }
                }

                return res;
            };

            stringUtils.decodeValue = function (value) {
                var res = [];

                while (value) {
                    var delim = value.indexOf(","), len = parseInt(value.substr(0, delim), 10);

                    res.push(value.substr(delim + 1, len));

                    value = value.substr(delim + 1 + len);
                }

                return res;
            };
            return stringUtils;
        })();
        gridview.stringUtils = stringUtils;
    })(c1.gridview || (c1.gridview = {}));
    var gridview = c1.gridview;
})(c1 || (c1 = {}));

var c1;
(function (c1) {
    (function (gridview) {
        /** @ignore */
        var SketchHierarchyDetailRow = (function (_super) {
            __extends(SketchHierarchyDetailRow, _super);
            function SketchHierarchyDetailRow(originalRowIndex, renderState, attrs) {
                _super.call(this, originalRowIndex, renderState, attrs);
                this.rowType = 2 /* data */ | 512 /* dataDetail */; // no alternating rows
            }
            return SketchHierarchyDetailRow;
        })(wijmo.grid.SketchDataRow);
        gridview.SketchHierarchyDetailRow = SketchHierarchyDetailRow;
    })(c1.gridview || (c1.gridview = {}));
    var gridview = c1.gridview;
})(c1 || (c1 = {}));

var c1;
(function (c1) {
    // columns
    (function (gridview) {
        var $ = jQuery;

        

        function getHeaderContent(column) {
            var innerState = column.options.innerState;

            return (innerState && innerState._resolvedHeaderImageUrl) ? "<img src=\"" + innerState._resolvedHeaderImageUrl + "\" />" : column.options.headerText || "&nbsp;";
        }

        //#region c1gridviewband
        /** @ignore */
        var c1gridviewbandfield = (function (_super) {
            __extends(c1gridviewbandfield, _super);
            function c1gridviewbandfield() {
                _super.apply(this, arguments);
            }
            c1gridviewbandfield.prototype._getHeaderContent = function () {
                return getHeaderContent(this);
            };
            return c1gridviewbandfield;
        })(wijmo.grid.c1bandfield);
        gridview.c1gridviewbandfield = c1gridviewbandfield;

        

        /** @ignore */
        var c1gridviewbandfield_options = (function (_super) {
            __extends(c1gridviewbandfield_options, _super);
            function c1gridviewbandfield_options() {
                _super.apply(this, arguments);
            }
            return c1gridviewbandfield_options;
        })(wijmo.grid.c1bandfield_options);
        gridview.c1gridviewbandfield_options = c1gridviewbandfield_options;

        c1gridviewbandfield.prototype.options = wijmo.grid.extendWidgetOptions(wijmo.grid.c1bandfield.prototype.options, new c1gridviewbandfield_options());

        //#endregion
        //#region c1gridviewtableboundfield
        /** @ignore */
        var c1gridviewtableboundfield = (function (_super) {
            __extends(c1gridviewtableboundfield, _super);
            function c1gridviewtableboundfield(wijgrid, options, widgetName) {
                _super.call(this, wijgrid, options, widgetName);

                this.mWrappedField = (options && options.dataType === "boolean") ? new wijmo.grid.c1booleanfield(wijgrid, options, widgetName) : new wijmo.grid.c1field(wijgrid, options, widgetName);
            }
            c1gridviewtableboundfield.prototype._provideDefaults = function () {
                _super.prototype._provideDefaults.apply(this, arguments);
                this.options.ensurePxWidth = true;
            };

            c1gridviewtableboundfield.prototype._setupDataCell = function (container, formattedValue, row) {
                var grid = this._owner(), editIndex = grid.options.innerState._bodyEditIndex;

                // сheck renderCounter because original cells are becomes empty after the first rendering
                if (!grid.mRenderCounter && (row.state === 1 /* rendering */)) {
                    if (row.type & 512 /* dataDetail */) {
                        return;
                    } else {
                        if ((editIndex >= 0) && (this.options.readOnly === false) && !grid._processingPartialCallback()) {
                            if (row.dataItemIndex + grid.mDataOffset === editIndex) {
                                return;
                            }
                        }
                    }
                }

                //super._setupDataCell.apply(this, arguments);
                this.mWrappedField._setupDataCell.apply(this, arguments);
            };

            c1gridviewtableboundfield.prototype._cellRendered = function (cell, container, row) {
                this.mWrappedField._cellRendered.apply(this, arguments); // to enable single-click behaviour for c1checkboxfield.
            };

            c1gridviewtableboundfield.prototype._getHeaderContent = function () {
                return getHeaderContent(this);
            };

            c1gridviewtableboundfield.prototype._canDropTo = function (column) {
                return _super.prototype._canDropTo.apply(this, arguments) && !column.options._dynamic;
            };

            c1gridviewtableboundfield.prototype._isSortable = function () {
                return _super.prototype._isSortable.apply(this, arguments) && (this.options.sortExpression !== undefined);
            };

            c1gridviewtableboundfield.prototype._needToEncodeValue = function (row) {
                var grid = this._owner();

                if (grid) {
                    if (grid._processingPartialCallback()) {
                        return false;
                    }

                    if (!this.options.readOnly && grid._isServerSideEditRow(row)) {
                        return false;
                    }
                }

                return _super.prototype._needToEncodeValue.apply(this, arguments);
            };

            c1gridviewtableboundfield.prototype._postset_width = function (value, oldValue) {
                var grid = this._owner(), flag = grid instanceof $.wijmo.c1detailgridview;

                try  {
                    if (flag) {
                        grid._ignoreSizing(false);
                    }
                    _super.prototype._postset_width.apply(this, arguments);
                } finally {
                    if (flag) {
                        grid._ignoreSizing(true);
                    }
                }
            };
            return c1gridviewtableboundfield;
        })(wijmo.grid.c1field);
        gridview.c1gridviewtableboundfield = c1gridviewtableboundfield;

        

        /** @ignore */
        var c1gridviewtableboundfield_options = (function (_super) {
            __extends(c1gridviewtableboundfield_options, _super);
            function c1gridviewtableboundfield_options() {
                _super.apply(this, arguments);
            }
            return c1gridviewtableboundfield_options;
        })(wijmo.grid.c1field_options);
        gridview.c1gridviewtableboundfield_options = c1gridviewtableboundfield_options;

        c1gridviewtableboundfield.prototype.options = wijmo.grid.extendWidgetOptions(wijmo.grid.c1field.prototype.options, new c1gridviewtableboundfield_options());

        //#endregion
        //#region c1gridviewboundfield
        /** @ignore */
        var c1gridviewboundfield = (function (_super) {
            __extends(c1gridviewboundfield, _super);
            function c1gridviewboundfield(wijgrid, options, widgetName) {
                _super.call(this, wijgrid, options, widgetName);

                options.encodeHtml = this.options.htmlEncode;
            }
            c1gridviewboundfield.prototype._provideDefaults = function () {
                _super.prototype._provideDefaults.apply(this, arguments);
                wijmo.grid.shallowMerge(this.options, c1gridviewboundfield.prototype.options);
            };

            c1gridviewboundfield.prototype._onFilterEditorValueChanged = function (args) {
                if (args.value instanceof Date) {
                    args.value = c1.gridview.truncDateTime(args.value, this.options.dataFormatString);
                }

                this.options.innerState.newFilterValue = args.value;
            };
            return c1gridviewboundfield;
        })(c1gridviewtableboundfield);
        gridview.c1gridviewboundfield = c1gridviewboundfield;

        

        

        /** @ignore */
        var c1gridviewboundfield_options = (function (_super) {
            __extends(c1gridviewboundfield_options, _super);
            function c1gridviewboundfield_options() {
                _super.apply(this, arguments);
                this.applyFormatInEditMode = false;
                this.dataField = undefined;
                this.convertEmptyStringToNull = true;
                this.htmlEncode = true;
            }
            return c1gridviewboundfield_options;
        })(c1gridviewtableboundfield_options);
        gridview.c1gridviewboundfield_options = c1gridviewboundfield_options;

        /** @ignore */
        var c1gridviewtemplatefield_options = (function (_super) {
            __extends(c1gridviewtemplatefield_options, _super);
            function c1gridviewtemplatefield_options() {
                _super.apply(this, arguments);
                this.filterExpression = "";
            }
            return c1gridviewtemplatefield_options;
        })(c1gridviewboundfield_options);
        gridview.c1gridviewtemplatefield_options = c1gridviewtemplatefield_options;

        c1gridviewboundfield.prototype.options = wijmo.grid.extendWidgetOptions(c1gridviewtableboundfield.prototype.options, new c1gridviewboundfield_options());

        //#endregion
        /** @ignore */
        var c1gridviewautogeneratedfield = (function (_super) {
            __extends(c1gridviewautogeneratedfield, _super);
            function c1gridviewautogeneratedfield() {
                _super.apply(this, arguments);
            }
            c1gridviewautogeneratedfield.prototype._provideDefaults = function () {
                _super.prototype._provideDefaults.apply(this, arguments);
                this.options._dynamic = true;
                this.options.showFilter = false;
            };

            c1gridviewautogeneratedfield.prototype._isSortable = function () {
                return true;
            };

            c1gridviewautogeneratedfield.prototype._canDrag = function () {
                return false;
            };
            return c1gridviewautogeneratedfield;
        })(c1gridviewboundfield);
        gridview.c1gridviewautogeneratedfield = c1gridviewautogeneratedfield;

        /** @ignore */
        var c1gridviewcheckboxfield = (function (_super) {
            __extends(c1gridviewcheckboxfield, _super);
            function c1gridviewcheckboxfield() {
                _super.apply(this, arguments);
            }
            c1gridviewcheckboxfield.prototype._provideDefaults = function () {
                _super.prototype._provideDefaults.apply(this, arguments);

                this.options.applyFormatInEditMode = false;
                this.options.convertEmptyStringToNull = false;
                this.options.htmlEncode = false;
            };

            c1gridviewcheckboxfield.prototype._setupDataCell = function (container, formattedValue, row) {
                return;
            };
            return c1gridviewcheckboxfield;
        })(c1gridviewboundfield);
        gridview.c1gridviewcheckboxfield = c1gridviewcheckboxfield;

        /** @ignore */
        var c1gridviewtemplatefield = (function (_super) {
            __extends(c1gridviewtemplatefield, _super);
            function c1gridviewtemplatefield() {
                _super.apply(this, arguments);
            }
            c1gridviewtemplatefield.prototype._setupHeaderCell = function () {
                if (!this.options.innerState._htmpl) {
                    _super.prototype._setupHeaderCell.apply(this, arguments);
                }
            };

            c1gridviewtemplatefield.prototype._setupDataCell = function (container, formattedValue, rowInfo) {
                if ((rowInfo.type & 512 /* dataDetail */) || !this.options.innerState._itmpl) {
                    _super.prototype._setupDataCell.apply(this, arguments);
                }
            };

            c1gridviewtemplatefield.prototype._setupFooterCell = function (container) {
                if (!this.options.innerState._ftmpl) {
                    _super.prototype._setupFooterCell.apply(this, arguments);
                }
            };

            c1gridviewtemplatefield.prototype._onFilterEditorValueChanged = function (args) {
                if (args.value instanceof Date) {
                    args.value = c1.gridview.truncDateTime(args.value, this.options.dataFormatString);
                }

                this.options.innerState.newFilterValue = args.value;
            };
            return c1gridviewtemplatefield;
        })(c1gridviewtableboundfield);
        gridview.c1gridviewtemplatefield = c1gridviewtemplatefield;
        c1gridviewtemplatefield.prototype.options = wijmo.grid.extendWidgetOptions(c1gridviewboundfield.prototype.options, new c1gridviewtemplatefield_options());

        /** @ignore */
        var c1gridviewhyperlinkfield = (function (_super) {
            __extends(c1gridviewhyperlinkfield, _super);
            function c1gridviewhyperlinkfield() {
                _super.apply(this, arguments);
            }
            return c1gridviewhyperlinkfield;
        })(c1gridviewtableboundfield);
        gridview.c1gridviewhyperlinkfield = c1gridviewhyperlinkfield;

        /** @ignore */
        var c1gridviewimagefield = (function (_super) {
            __extends(c1gridviewimagefield, _super);
            function c1gridviewimagefield() {
                _super.apply(this, arguments);
            }
            return c1gridviewimagefield;
        })(c1gridviewtableboundfield);
        gridview.c1gridviewimagefield = c1gridviewimagefield;

        /** @ignore */
        var c1gridviewbuttonfield = (function (_super) {
            __extends(c1gridviewbuttonfield, _super);
            function c1gridviewbuttonfield() {
                _super.apply(this, arguments);
            }
            return c1gridviewbuttonfield;
        })(c1gridviewtableboundfield);
        gridview.c1gridviewbuttonfield = c1gridviewbuttonfield;

        /** @ignore */
        var c1gridviewcommandfield = (function (_super) {
            __extends(c1gridviewcommandfield, _super);
            function c1gridviewcommandfield() {
                _super.apply(this, arguments);
            }
            c1gridviewcommandfield.prototype._setupFilterCell = function (container) {
                if (this.options.dataIndex >= 0) {
                    var grid = this._owner(), tHead = grid._tHead();

                    if (tHead && tHead.length) {
                        container.html(tHead[tHead.length - 1][this.options.dataIndex]);
                    }
                    // Intercept changing of the cell content (A "Filter" command button).
                }
            };
            return c1gridviewcommandfield;
        })(c1gridviewtableboundfield);
        gridview.c1gridviewcommandfield = c1gridviewcommandfield;

        var c1detailheaderfield = (function (_super) {
            __extends(c1detailheaderfield, _super);
            function c1detailheaderfield(wijgrid, options, widgetName) {
                _super.call(this, wijgrid, options, widgetName || c1detailheaderfield.WIDGET_NAME);
            }
            /** @ignore */
            c1detailheaderfield.getInitOptions = function () {
                var opts = wijmo.grid.c1rowheaderfield.getInitOptions();
                opts._clientType = c1detailheaderfield.CLIENT_TYPE;
                return opts;
            };

            c1detailheaderfield.test = function (column) {
                return column._clientType === c1detailheaderfield.CLIENT_TYPE;
            };

            c1detailheaderfield.prototype._setupDataCell = function (container, formattedValue, row) {
                var _this = this;
                if (row.type & 512 /* dataDetail */) {
                    this._updateHTML(row, container, "&nbsp;");
                } else {
                    var html = this._getToggleButtonHtml((row._extInfo.state & 2 /* collapsed */) != 0);

                    this._updateHTML(row, container, html);

                    container.find("." + this._defCSS().groupToggleVisibilityButton).click(function (e) {
                        _this._owner()._onToggleHierarchy(e, row);
                    });
                }
            };
            c1detailheaderfield.CLIENT_TYPE = "c1detailheaderfield";

            c1detailheaderfield.WIDGET_NAME = "wijmo.c1detailheaderfield";
            return c1detailheaderfield;
        })(wijmo.grid.c1rowheaderfield);
        gridview.c1detailheaderfield = c1detailheaderfield;

        wijmo.grid.registerColumnFactory(function (grid, column) {
            var instance = null;

            switch (column._clientType) {
                case "c1band":
                    column.showFilter = false;
                    column.readOnly = true;
                    instance = new c1gridviewbandfield(grid, column);
                    break;

                case "c1boundfield":
                    instance = new c1gridviewboundfield(grid, column);
                    break;

                case "c1hyperlinkfield":
                    column.showFilter = false;
                    column.readOnly = true;
                    instance = new c1gridviewhyperlinkfield(grid, column);
                    break;

                case "c1imagefield":
                    column.showFilter = false;
                    column.readOnly = true;
                    instance = new c1gridviewimagefield(grid, column);
                    break;

                case "c1templatefield":
                    column.showFilter = column["dataField"] ? column.showFilter : false;
                    column.readOnly = true;
                    instance = new c1gridviewtemplatefield(grid, column);
                    break;

                case "c1buttonfield":
                    column.showFilter = false;
                    column.readOnly = true;
                    instance = new c1gridviewbuttonfield(grid, column);
                    break;

                case "c1autogeneratedfield":
                    instance = new c1gridviewautogeneratedfield(grid, column);
                    break;

                case "c1checkboxfield":
                    instance = new c1gridviewcheckboxfield(grid, column);
                    break;

                case "c1commandfield":
                    column.allowSort = false;
                    column.showFilter = false;
                    column.readOnly = true;

                    if (column._dynamic) {
                        column.allowMoving = false;
                    }

                    instance = new c1gridviewcommandfield(grid, column);
                    break;

                case "c1detailheaderfield":
                    instance = new c1detailheaderfield(grid, column);
                    break;
            }

            return instance;
        });

        if (wijmo.exporter && wijmo.exporter.exportContext) {
            var exportContextPrototype = wijmo.exporter.exportContext.prototype, wijIsCheckBoxCol = exportContextPrototype.isCheckBoxCol, wijIsHtmlCol = exportContextPrototype.isHtmlCol, wijIsImageCol = exportContextPrototype.isImageCol, wijIsLinkCol = exportContextPrototype.isLinkCol, gridExporter = wijmo.exporter.gridExporter, originCreateGridWithExport = gridExporter.createGridWithExport;

            exportContextPrototype.isCheckBoxCol = function (col) {
                return col instanceof c1gridviewcheckboxfield || wijIsCheckBoxCol.apply(this, arguments);
            };

            exportContextPrototype.isHtmlCol = function (col) {
                return col instanceof c1gridviewtemplatefield || wijIsHtmlCol.apply(this, arguments);
            };

            exportContextPrototype.isImageCol = function (col) {
                return col instanceof c1gridviewimagefield || wijIsImageCol.apply(this, arguments);
            };

            exportContextPrototype.isLinkCol = function (col) {
                return col instanceof c1gridviewhyperlinkfield || col instanceof c1gridviewcommandfield || col instanceof c1gridviewbuttonfield || wijIsLinkCol.apply(this, arguments);
            };

            if (originCreateGridWithExport) {
                gridExporter.createGridWithExport = function (setting, newOptions, exportAction) {
                    if (setting.grid instanceof wijmo.grid.wijgrid) {
                        originCreateGridWithExport(setting, newOptions, exportAction);
                        return;
                    }

                    var grid = setting.grid, $gridElement = $(grid.element), id = $gridElement.attr("id"), oldOptions = grid.options, cloneElement = function ($element) {
                        return $($element[0].outerHTML).removeAttr("id").empty();
                    }, container = cloneElement(grid.element.closest(".c1gridview-marker")).addClass("wijmo-wijgrid");

                    //change options to make all data show in a single table
                    grid.options = newOptions;

                    //requst all data
                    $gridElement.wijSaveState("c1gridview", "onwijstatesaving");
                    c1common.updateWebFormsInternals(id, __JSONC1.stringify(grid.onwijstatesaving()));
                    WebForm_DoCallback(oldOptions.innerState._uid, newOptions.allowPaging ? ("page:" + newOptions.pageIndex) : "render", function (result) {
                        // generate a temp grid which shows all data in a single table
                        var response = jQuery.parseJSON(result), options = wijmoASPNetParseOptions(jQuery.parseJSON(response.options));

                        options.rendered = gridExporter.createGridRendered(setting, exportAction, container);

                        // For fixing bug 73562: scrollMode's (de)serialization has problem after it is obsoleted.
                        // So force to set it to "none" here.
                        options.scrollMode = "none";

                        container.appendTo($(document.body));

                        $(response.entity.html).filter("table").eq(0).appendTo(container).c1gridview(options);
                    }, null, null, true);

                    //change the option back
                    grid.options = oldOptions;
                };
            }
        }
    })(c1.gridview || (c1.gridview = {}));
    var gridview = c1.gridview;
})(c1 || (c1 = {}));

var c1;
(function (c1) {
    // grouped column header
    (function (gridview) {
        var $ = jQuery;

        var c1gridviewgroupedfield = (function (_super) {
            __extends(c1gridviewgroupedfield, _super);
            function c1gridviewgroupedfield(grid, options, element) {
                _super.call(this, grid, options, element);
            }
            c1gridviewgroupedfield.prototype._isSortable = function () {
                var grid = this._owner(), original = grid._findInstance(this.options);

                return _super.prototype._isSortable.apply(this, arguments) && ((this.options.sortExpression !== undefined) || (original instanceof gridview.c1gridviewautogeneratedfield));
            };
            return c1gridviewgroupedfield;
        })(wijmo.grid.c1groupedfield);
        gridview.c1gridviewgroupedfield = c1gridviewgroupedfield;
    })(c1.gridview || (c1.gridview = {}));
    var gridview = c1.gridview;
})(c1 || (c1 = {}));

var c1;
(function (c1) {
    

    /** @ignore */
    var c1detailgridview = (function (_super) {
        __extends(c1detailgridview, _super);
        function c1detailgridview() {
            _super.apply(this, arguments);
        }
        //#region sizing
        c1detailgridview.prototype._onWindowResize = function () {
            // reset size, so the root grid can calculate its sizes correctly
            this._topmostElement().width("");
            this._view()._resetWidth();
            return;
        };

        c1detailgridview.prototype._setSizeInternal = function (scrollValue) {
            if (this._ignoreSizing()) {
                return;
            }
            this._topmostElement().width(""); // reset
            _super.prototype._setSizeInternal.apply(this, arguments);
        };

        //#endregion
        c1detailgridview.prototype._callbackAction = function () {
            var parent = this._parent();

            return parent ? parent._callbackAction() : 0 /* none */;
        };
        return c1detailgridview;
    })(c1.c1gridview);
    c1.c1detailgridview = c1detailgridview;

    c1detailgridview.prototype.widgetEventPrefix = "c1detailgridview";

    c1detailgridview.prototype.options = $.extend(true, {}, $.wijmo.c1gridview.prototype.options, {
        path: undefined
    });

    $.wijmo.registerWidget("c1detailgridview", $.wijmo.c1gridview, c1detailgridview.prototype);
})(c1 || (c1 = {}));
